setwd("/home/thom/Dropbox/Partners/A2I2/5-GAMMI/")

files <- list.files(c("results-dang/no_attn_tune/",
                      "results-dang/with_attn_simple_tune/"), full.names = TRUE)
news <- lapply(files, function(x) data.frame("Method" = basename(x), read.csv(x)))
new <- do.call("rbind", news)

means <- aggregate(auc ~ dataset, new, mean)
merged <- merge(new, means, by.x = 2, by.y = 1)
merged$diff <- merged$auc.x - merged$auc.y
merged$Type <- ifelse(grepl("without", merged$Method), "Without Self-explanation", "With Self-explanation")

library(ggplot2)
g <- ggplot(merged, aes(x = factor(cascade_lvl), y = diff, fill = factor(l1_lambda))) +
  facet_grid(factor(Type)~.) + scale_fill_brewer(palette = "Spectral") +
  geom_violin() + ylim(-1, .5) +
  ylab("Difference Between Classifier AUC and Data Set Average\n(across discovery set)") +
  xlab("Number of Log-bottlenecks") +
  labs(fill = "L1 penalty") +
  theme_bw()

library(miSciTools)
fig.save(plot(g), file = "a-viz-tuning")

sink("a-viz-tuning.txt")
best <- aggregate(diff ~ cascade_lvl + l1_lambda + Type, merged, median)
best[order(best$diff),]
sink()
