# This is from a model trained on the whole data set...
setwd("/home/thom/Dropbox/Partners/A2I2/5-GAMMI/")

# Get the ATTENTION
attn <- read.csv("results-dang/2a_weights/w_attn_map_x_beta_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv",
                 row.names = 1, header = FALSE)

# Get the BOTTLENECKS
z <- read.csv("results-dang/2a_weights/w_attn_map_x_z_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv",
              row.names = 1, head = FALSE)

# Get the CLINICAL DATA
y <- read.csv("results-dang/2a_weights/ibd-y.csv",
              row.names = 1)

# Calculate BOTTLENECKS
x <- read.csv("data-out/dba-data/2a-franzosa-mic-ibd-v-hc-x.csv", row.names = 1)
logx <- log(x)
degree <- read.csv("results-dang/2a_weights/w_attn_wei_logs_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv")
a <- miSciTools::long2wide(weight_value ~ cascade_lvl_id + weight_id, degree)
rownames(a) <- a[,1]
colnames(a) <- 1:ncol(a)
a <- a[-1]
z1 <- lapply(1:nrow(a), function(bottleneck){
  apply(logx, 1, function(sample) sum(sample*a[bottleneck,]))
})
z1 <- do.call("cbind", z)
plot(z[,1], z1[,1]) # OK

# Do rownames agree?
identical(rownames(attn), rownames(y))
identical(rownames(z), rownames(y))

png("d-interpret-2a-panels.png", width = 10, height = 5, units = "in", res = 600)
par(mfrow = c(2,5))
for(i in 1:5){
  plot(z[,i], attn[,i], col = ifelse(y$Diagnosis == "Control", "orange", "purple"),
       xlab = paste0("z", i), ylab = paste0("w", i), pch=16,
       main = paste0("Bottleneck ", i), cex.lab = 1.4)
}
for(i in 1:5){
  prod <- z * attn
  pred <- ROCR::prediction(prod[,i], as.numeric(y$Diagnosis != "Control"))
  perf <- ROCR::performance(pred,"tpr","fpr")
  ROCR::plot(perf, main = paste0("w", i, " * z", i, " ROC"), cex.lab = 1.4)
}
dev.off()

# Clean up ID names
colnames(z) <- paste0("z", 1:5)
colnames(attn) <- paste0("w", 1:5)

# Plot CanCor
png("d-interpret-2a-cancor.png", width = 5, height = 5, units = "in", res = 600)
library(vegan)
can <- vegan::CCorA(z, attn)
biplot(can, cex = c(1.2, 1.2))
dev.off()

system("convert d-interpret-2a-cancor.png -crop 100%x50% d-interpret-2a-half.png")
system("convert d-interpret-2a-half-1.png -crop 50%x100% d-interpret-2a-qtr.png")
system("convert -append d-interpret-2a-qtr-3.png d-interpret-2a-qtr-2.png d-interpret-2a-half-c.png")
system("convert +append d-interpret-2a-panels.png d-interpret-2a-half-c.png d-interpret-2a-merged.png")
