# This is from a model trained on the whole data set...
setwd("/home/thom/Dropbox/Partners/A2I2/5-GAMMI/")

# Get the ATTENTION
attn <- read.csv("results-dang/2a_weights/w_attn_map_x_beta_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv",
                 row.names = 1, header = FALSE)

# Get the BOTTLENECKS
z <- read.csv("results-dang/2a_weights/w_attn_map_x_z_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv",
              row.names = 1, head = FALSE)

# Get the CLINICAL DATA
y <- read.csv("results-dang/2a_weights/ibd-y.csv",
              row.names = 1)

# Calculate BOTTLENECKS
x <- read.csv("data-out/dba-data/2a-franzosa-mic-ibd-v-hc-x.csv", row.names = 1)
logx <- log(x)
degree <- read.csv("results-dang/2a_weights/w_attn_wei_logs_2a-franzosa-mic-ibd-v-hc_lvl_5_l1_0.01.csv")
a <- miSciTools::long2wide(weight_value ~ cascade_lvl_id + weight_id, degree)
rownames(a) <- a[,1]
colnames(a) <- 1:ncol(a)
a <- a[-1]
z1 <- lapply(1:nrow(a), function(bottleneck){
  apply(logx, 1, function(sample) sum(sample*a[bottleneck,]))
})
z1 <- do.call("cbind", z)
plot(z[,1], z1[,1]) # OK

# Do rownames agree?
identical(rownames(attn), rownames(y))
identical(rownames(z), rownames(y))

# Look at random healthy boy
set.seed(1)
rand_control <- sample(which(y$Diagnosis == "Control"))[1]
rand_case <- sample(which(y$Diagnosis != "Control"))[1]
s1 <- z[rand_control,]
w1 <- attn[rand_control,]
s1*w1 # the product are the DECISION SCORES
sum(s1 * w1) # negative is healthy

# Look at random sick boy
s2 <- z[rand_case,]
w2 <- attn[rand_case,]
s2*w2 # the product are the DECISION SCORES
sum(s2 * w2) # positive is sick
s2

# Find maximum / minimum bacteria for log-contrast 3...
colnames(a) <- NULL
colnames(x)[which.max(a[3,])]
colnames(x)[which.min(a[3,])]
