setwd("/home/thom/Dropbox/Partners/A2I2/5-GAMMI/WithThom/data-out/n=1000/")
set.seed(1)
r <- lapply(1:10, function(var){
  rnbinom(1000, mu = 100, size = 10)
})
x <- do.call("cbind", r)
write.csv(x, file = "0-sim_data-x1.csv")

# Main and ever-decreasing interactions
y <- x[,1] + x[,2] + x[,3] +
  (.5 * x[,2] * x[,3]) + (.25 * x[,4] * x[,5]) +
  (.1 * x[,6]^2) + (.05 * x[,5] * x[,6])
write.csv(y, file = "0-sim_data-f1.csv")

# Main effects only
y <- x[,1] + .8 * x[,2] + .6 * x[,3] + .4 * x[,4] + .2 * x[,5]
write.csv(y, file = "0-sim_data-f2.csv")

# Interactions overlap
y <- x[,1] + x[,2] + x[,3] +
  (x[,2]^2 * x[,3]) + (x[,2] * x[,3]^2) + (x[,2] * x[,3] * x[,4])
write.csv(y, file = "0-sim_data-f3.csv")

# Interactions overlap
y <- x[,1] + x[,2] + x[,3] +
  (x[,2] * x[,3]) + (x[,3] * x[,4]) + (x[,4] * x[,5])
write.csv(y, file = "0-sim_data-f4.csv")

# Interactions only
y <- (x[,1] * x[,2]) + (.8 * x[,2] * x[,3]) + (.6 * x[,3] * x[,4]) +
  (.4 * x[,3] * x[,5]) + (.2 * x[,6] * x[,7])
write.csv(y, file = "0-sim_data-f5.csv")

r2 <- lapply(1:90, function(var){
  rnbinom(1000, mu = 100, size = 10)
})
x2 <- do.call("cbind", c(r, r2))
write.csv(x2, file = "0-sim_data-x2.csv")

r3 <- lapply(1:900, function(var){
  rnbinom(1000, mu = 100, size = 10)
})
x3 <- do.call("cbind", c(r, r2, r3))
write.csv(x3, file = "0-sim_data-x3.csv")
