x <- read.csv("/home/thom/Dropbox/Partners/A2I2/5-GAMMI/data-out/n=1000/0-sim_data-x1.csv",
              row.names = 1)

y <- x[,1]*x[,2] + x[,2]*x[,3]
y <- data.frame("y" = y)

# Fit log-linear model to approximate true interaction set
lm(y ~ . + 0, cbind(log(y), log(x)))
yhat <- x[,1]^(1/2) * x[,2] * x[,3]^(1/2)
y <- unlist(y)

# This is loss of the log-linear model
plot(y, yhat)

# Relative error is big when the absolute error is small
plot(y - yhat, y/yhat)

# Relative error is high when a or c are small
plot(x[,1], y - yhat)
plot(x[,1], y/ yhat)
plot(x[,2], y/ yhat)
plot(x[,3], y/ yhat)

# Relative error is big when the whole product is small
product <- apply(x[,1:3], 1, prod)
plot(product, y/yhat)

res <- vector('list', 21^3)
count <- 1
for(i in seq(0, 1, 1/20)){
  for(j in seq(0, 1, 1/20)){
    for(k in seq(0, 1, 1/20)){
      if(i>0|j>0|k>0){
        yhat <- x[,1]^(i) * x[,2]^(j) * x[,3]^(k)
        minn <- apply(x[,1:3], 1, min)
        index <- (1:3)[c(i>0, j>0, k>0)]
        minn2 <- apply(x[,index,drop=FALSE], 1, min)
        penalty <- (max(minn) - minn)
        #penalty <- (penalty - min(penalty)) / (max(penalty) - min(penalty))
        res[[count]] <- data.frame(i,
                                   j,
                                   k,
                                   "Abs" = sum((y - yhat)^2),
                                   "Rel" = sum((y / yhat)),
                                   "P1" = cor(penalty, y/yhat),
                                   "P2" = abs(cor(minn, y/yhat)),
                                   "P3" = abs(cor(minn, log(y/yhat))),
                                   "P4" = sum((abs(yhat-y))/y)
        )
      }else{
        res[[count]] <- NULL
      }
      count <- count+1
    }
  }
}
res <- do.call("rbind", res)

# See what powers minimize what errors
plot(res$Abs, res$Rel)
res[which.min(res$Rel), ]
res[which.min(res$Abs), ]

# Looks like [1, 1, 1] minimizes relative error...
# But relative error is still highest when the product is small...
plot(x[,1]*x[,2]*x[,3], y)
plot(x[,1]^(1/2) * x[,2] * x[,3]^(1/2), y)
plot(x[,1]*x[,2]*x[,3], y/(x[,1]*x[,2]*x[,3]))
plot(x[,1]^(1/2) * x[,2] * x[,3]^(1/2), y/(x[,1]*x[,2]*x[,3]))

# Does the test Loss function fix this?
res[which.min(res$P1), ]
res[which.min(res$P2), ]
res[which.min(res$P3), ]
res[which.min(res$P4), ]

# # # # 
# # Try L0 regularization
# for(lambda in 10^(1:20)){
#   print(
#     res[which.min(res$Rel + lambda*((res[,1]>0)+(res[,2]>0)+(res[,3]>0))),]
#   )
# }
